"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var directory_tree_1 = __importDefault(require("directory-tree"));
var node_emoji_1 = require("node-emoji");
var pdf_from_html_1 = __importDefault(require("pdf-from-html"));
var organize_1 = require("./organize");
var highlight_js_1 = require("highlight.js");
var markdown_it_emoji_1 = __importDefault(require("markdown-it-emoji"));
var mustache_1 = require("mustache");
// tslint:disable-next-line: no-var-requires
var md = require('markdown-it')({
    highlight: function (str, lang) {
        if (lang && highlight_js_1.getLanguage(lang)) {
            try {
                return "<pre class=\"hljs\"><code>" + highlight_js_1.highlight(lang, str, true).value + "</code></pre>";
                // tslint:disable-next-line: no-empty
            }
            catch (__) { }
        }
        return "<pre class=\"hljs\"><code>" + md.utils.escapeHtml(str) + "</code></pre>";
    },
    html: true,
    linkify: true,
    typographer: true,
});
md.use(markdown_it_emoji_1.default);
md.renderer.rules.emoji = function (token, idx) { return "<i class=\"twa twa-" + token[idx].markup + "\"></i>"; };
var Generate = /** @class */ (function () {
    function Generate(files, exclude, inputPath, outputPath) {
        var _this = this;
        this.htmlDefaultTemplatePath = 'dist/template/html/index.html';
        this.pdfDefaultTemplatePath = 'dist/template/pdf/index.html';
        this.contracts = [];
        this.fixUrls = function (content) {
            var match = content.match(/(?<!\[)https?:&#x2F;&#x2F;[a-zA-Z0-9.&#x2F;\-_]+/g);
            if (match !== null) {
                var transform = match.map(function (url) { return url.replace(/&#x2F;/g, '/'); });
                transform = transform.map(function (url) { return "<a href=\"" + url + "\">" + url + "</a>"; });
                for (var i = 0; i < match.length; i += 1) {
                    content = content.replace(match[i], transform[i]);
                }
            }
            return content;
        };
        this.applyEmojify = function (content) {
            var formatEmojify = function (code, name) { return "<i alt=\"" + code + "\" class=\"twa twa-" + name + "\"></i>"; };
            return node_emoji_1.emojify(content, null, formatEmojify);
        };
        files.forEach(function (file) { return _this.contracts.push(organize_1.prepareForFile(file)); });
        this.outputPath = outputPath;
        this.inputPathStructure = directory_tree_1.default(inputPath, { exclude: exclude.map(function (i) { return new RegExp(i); }) });
        this.hasLICENSE = fs_1.default.existsSync(path_1.default.join(process.cwd(), 'LICENSE'));
    }
    /**
     * TODO: to write!
     */
    Generate.prototype.html = function () {
        var _this = this;
        this.contracts.forEach(function (contract) {
            var HTMLContent = _this.mustacheRender(path_1.default.join(contract.folder, _this.htmlDefaultTemplatePath), contract);
            HTMLContent = _this.fixUrls(HTMLContent);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), _this.outputPath, contract.filename + ".html"), _this.applyEmojify(HTMLContent));
        });
        if (fs_1.default.existsSync(path_1.default.join(process.cwd(), 'README.md'))) {
            var templateContent = String(fs_1.default.readFileSync(path_1.default.join(this.contracts[0].folder, this.htmlDefaultTemplatePath)));
            var pureREADME = String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'README.md'))).trim();
            var view = {
                README: md.render(pureREADME),
                contractsStructure: this.contracts,
                folderStructure: JSON.stringify(this.inputPathStructure),
                hasLICENSE: this.hasLICENSE,
            };
            var outputReadme_1 = mustache_1.render(templateContent, view);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'index.html'), outputReadme_1);
            var files_1 = [];
            var filesList = fs_1.default.readdirSync(process.cwd());
            filesList.forEach(function (file) {
                var stats = fs_1.default.lstatSync(path_1.default.join(process.cwd(), file));
                if (stats.isFile() && path_1.default.extname(file) === '.png') {
                    files_1.push(file);
                }
            });
            files_1.forEach(function (file) {
                if (outputReadme_1.includes(file)) {
                    fs_1.default.copyFileSync(path_1.default.join(process.cwd(), file), path_1.default.join(process.cwd(), _this.outputPath, file));
                }
            });
        }
        if (this.hasLICENSE) {
            var templateContent = String(fs_1.default.readFileSync(path_1.default.join(this.contracts[0].folder, this.htmlDefaultTemplatePath)));
            var LICENSEText = String(fs_1.default.readFileSync(path_1.default.join(process.cwd(), 'LICENSE'))).trim();
            var LICENSE = LICENSEText.replace(/\n/g, '<br>');
            var view = {
                LICENSE: LICENSE,
                contractsStructure: this.contracts,
                folderStructure: JSON.stringify(this.inputPathStructure),
                hasLICENSE: true,
            };
            var outputLicense = mustache_1.render(templateContent, view);
            fs_1.default.writeFileSync(path_1.default.join(process.cwd(), this.outputPath, 'license.html'), outputLicense);
        }
        return 0;
    };
    /**
     * TODO: to write!
     */
    Generate.prototype.pdf = function () {
        var _this = this;
        this.contracts.forEach(function (contract) { return __awaiter(_this, void 0, void 0, function () {
            var HTMLContent;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        HTMLContent = this.mustacheRender(path_1.default.join(contract.folder, this.pdfDefaultTemplatePath), contract);
                        HTMLContent = this.fixUrls(HTMLContent);
                        return [4 /*yield*/, pdf_from_html_1.default.generatePDF(this.outputPath, contract.filename, this.applyEmojify(HTMLContent))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    /**
     * Using the given parameters, calls the Mustache engine
     * and renders the HTML page.
     * @param {string} templateFilePath Path for template file
     * @param {string} contract contract object
     */
    Generate.prototype.mustacheRender = function (templateFilePath, contract) {
        var templateContent = String(fs_1.default.readFileSync(templateFilePath));
        var view = {
            contract: contract,
            contracts: this.contracts,
            currentDate: new Date(),
            folderStructure: JSON.stringify(this.inputPathStructure),
            hasLICENSE: this.hasLICENSE,
        };
        var output = mustache_1.render(templateContent, view);
        return output;
    };
    return Generate;
}());
exports.Generate = Generate;
//# sourceMappingURL=generate.js.map