"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var generate_renderMD_1 = require("./generate_renderMD");
var lineBreak = '\r\n';
/**
 * @param contractsPreparedData prepared data
 */
function generateDocumentation(contractsPreparedData, outputFolder) {
    // create a list of contracts and methods
    var hasLICENSE = fs_1.default.existsSync(path_1.default.join(process.cwd(), 'LICENSE'));
    generate_renderMD_1.renderContracts(contractsPreparedData, outputFolder, lineBreak);
    // generate _sidebar file (essential in docsify, to have a custom sidebar)
    var SIDEBARContent = "* WELCOME" + lineBreak + "\t* [Home](/)" + lineBreak;
    SIDEBARContent = generate_renderMD_1.renderDocumentationIndex(SIDEBARContent, outputFolder, contractsPreparedData, hasLICENSE, lineBreak);
    // create _sidebar file
    fs_1.default.writeFileSync(path_1.default.join(process.cwd(), outputFolder, '_sidebar.md'), SIDEBARContent);
    // Copy readme if it exists, otherwise, create a sampe
    generate_renderMD_1.renderReadme(outputFolder);
    // copy html base
    fs_1.default.copyFileSync(path_1.default.join(__dirname, 'template/docsify/index.html'), path_1.default.join(process.cwd(), outputFolder, 'index.html'));
    // write nojekill
    fs_1.default.writeFileSync(path_1.default.join(process.cwd(), outputFolder, '.nojekill'), ' ');
}
exports.generateDocumentation = generateDocumentation;
//# sourceMappingURL=generate_docsify.js.map